//
// Created by #Suyghur, on 2021/06/11.
//

#ifndef COLUMBUS_AES_UTILS_H
#define COLUMBUS_AES_UTILS_H

#include "aes.h"

#define BLOCKLEN 16

#ifdef __cplusplus
extern "C" {
#endif

class AesUtils {
public:
    static uint8_t *GetKey();

    static uint8_t *GetIv(const uint8_t *key);

    /** AES加密, CBC, PKCS5Padding */
    static char *Encrypt(const char *input);

    /** AES解密, CBC, PKCS5Padding */
    static char *Decrypt(const char *input, const uint8_t *key);

private:
    static uint8_t *GetPaddingInput(const char *input);

    static int FindPaddingIndex(uint8_t *str, size_t length);

    static void RemovePadding(uint8_t *out, size_t length);
};


#ifdef __cplusplus
}
#endif


#endif //COLUMBUS_AES_UTILS_H
